/******************** (C) COPYRIGHT 2008 STMicroelectronics ********************
* File Name          : main.c
* Author             : MCD Application Team
* Version            : V2.0.1
* Date               : 06/13/2008
* Description        : Main program body.
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "stm32_eval.h"
/* Private typedef -----------------------------------------------------------*/

/* Private define ------------------------------------------------------------*/

/*ܽŶ*/
#define BEEPER_PIN                GPIO_Pin_10		   /*ʹõGPIOܽ*/
#define GPIO_BEEPER               GPIOB			       /*IIIŷʹõGPIO*/
#define BUZZER_GPIO_CLK           RCC_APB2Periph_GPIOB /*ʹõGPIOʱ*/


/* Private macro -------------------------------------------------------------*/

/* Private variables ---------------------------------------------------------*/
GPIO_InitTypeDef GPIO_InitStructure;
ErrorStatus HSEStartUpStatus;
u8 count=0;

/* Private function prototypes -----------------------------------------------*/
void Delay(vu32 nCount);

/* Private functions ---------------------------------------------------------*/

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main(void)
{
  	/*ʹܷʹõGPIOʱ*/
	RCC_APB2PeriphClockCmd(BUZZER_GPIO_CLK, ENABLE);

  	/*ʼʹõGPIOܽ*/
  	GPIO_InitStructure.GPIO_Pin = BEEPER_PIN;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIO_BEEPER, &GPIO_InitStructure);
 
  	while (1)
  	{	

		GPIO_SetBits(GPIO_BEEPER, BEEPER_PIN);     /*رշ*/ 
	    Delay(0x2FFFFF);  
		GPIO_ResetBits(GPIO_BEEPER,  BEEPER_PIN);	/**/
	    Delay(0x2FFFFF);

  	}
}


/*******************************************************************************
* Function Name  : Delay
* Description    : Inserts a delay time.
* Input          : nCount: specifies the delay time length.
* Output         : None
* Return         : None
*******************************************************************************/
void Delay(vu32 nCount)
{
  for(; nCount != 0; nCount--);
}


/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
