/**
  ******************************************************************************
  * @file    USART/Interrupt/platform_config.h 
  * @author  MCD Application Team
  * @version V3.3.0
  * @date    04/16/2010
  * @brief   Evaluation board specific configuration file.
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 STMicroelectronics</center></h2>
  */ 

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __PLATFORM_CONFIG_H
#define __PLATFORM_CONFIG_H

/* Includes ------------------------------------------------------------------*/

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Uncomment the line corresponding to the STMicroelectronics evaluation board
   used to run the example */
#if !defined (USE_STM3210B_EVAL) &&  !defined (USE_STM3210E_EVAL) &&  !defined (USE_STM3210C_EVAL) &&  !defined (USE_STM32100B_EVAL)
 #define USE_STM3210E_EVAL
#endif

/* Define the STM32F10x hardware depending on the used evaluation board */


  #define USART1_GPIO              GPIOA
  #define USART1_CLK               RCC_APB2Periph_USART1
  #define USART1_GPIO_CLK          RCC_APB2Periph_GPIOA
  #define USART1_RxPin             GPIO_Pin_10
  #define USART1_TxPin             GPIO_Pin_9
  #define USART1_IRQn              USART1_IRQn
  #define USART1_IRQHandler        USART1_IRQHandler
  
  #define USART2_GPIO              GPIOA
  #define USART2_CLK               RCC_APB1Periph_USART2
  #define USART2_GPIO_CLK          RCC_APB2Periph_GPIOA
  #define USART2_RxPin             GPIO_Pin_3
  #define USART2_TxPin             GPIO_Pin_2
  #define USART2_IRQn              USART2_IRQn
  #define USART2_IRQHandler        USART2_IRQHandler
  
/*IIILEDض*/
  #define RCC_GPIO_LED                    RCC_APB2Periph_GPIOF    /*LEDʹõGPIOʱ*/
  #define LEDn                            4                       /*IIILED*/
  #define GPIO_LED                        GPIOF                   /*IIILEDʹõGPIO*/
  
  #define DS1_PIN                         GPIO_Pin_6              /*DS1ʹõGPIOܽ*/
  #define DS2_PIN                         GPIO_Pin_7				/*DS2ʹõGPIOܽ*/
  #define DS3_PIN                         GPIO_Pin_8  			/*DS3ʹõGPIOܽ*/
  #define DS4_PIN                         GPIO_Pin_9				/*DS4ʹõGPIOܽ*/
  #define GPIO_LED_ALL                    (DS1_PIN |DS2_PIN |DS3_PIN |DS4_PIN)
  #define ON                              1
  #define OFF                             0
  /*IIIŰض*/
  #define RCC_KEY1                                    RCC_APB2Periph_GPIOD
  #define GPIO_KEY1_PORT                              GPIOD    
  #define GPIO_KEY1                                   GPIO_Pin_3
  
  #define RCC_KEY2                                    RCC_APB2Periph_GPIOA
  #define GPIO_KEY2_PORT                              GPIOA  
  #define GPIO_KEY2                                   GPIO_Pin_8
  
  #define RCC_KEY3                                    RCC_APB2Periph_GPIOC
  #define GPIO_KEY3_PORT                              GPIOC    
  #define GPIO_KEY3                                   GPIO_Pin_13 
  
  #define RCC_KEY4                                    RCC_APB2Periph_GPIOA
  #define GPIO_KEY4_PORT                              GPIOA    
  #define GPIO_KEY4                                   GPIO_Pin_0 
  
  #define GPIO_KEY_ANTI_TAMP                          GPIO_KEY3
  #define GPIO_KEY_WEAK_UP                            GPIO_KEY4
  
  
  /* Values magic to the Board keys */
  #define  NOKEY  0
  #define  KEY1   1
  #define  KEY2   2
  #define  KEY3   3
  #define  KEY4   4
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

#endif /* __PLATFORM_CONFIG_H */

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
