/******************** (C) COPYRIGHT 2009 www.armjishu.com ************************
* File Name          : main.c
* Author             : www.armjishu.com Team
* Version            : V3.3.0
* Date               : 09/30/2010
* Description        : 
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/

#include "stm32f10x.h"
#include "stm32f10x_usart.h"

/* Private typedef -----------------------------------------------------------*/
//typedef  void (*pFunction)(void);
/* Private define ------------------------------------------------------------*/
#define max_cmd 10
#define AudioFileAddressEnd 0x0805A000

/*IIILEDض*/
#define RCC_GPIO_LED                                 RCC_APB2Periph_GPIOF      /*LEDʹõGPIOʱ*/
#define GPIO_LED_PORT                                GPIOF                     /*IIILED*/
#define LEDn                                         4            /*IIILEDʹõGPIO*/
#define DS1_PIN                                      GPIO_Pin_6    /*DS1ʹõGPIOܽ*/
#define DS2_PIN                                      GPIO_Pin_7    /*DS2ʹõGPIOܽ*/
#define DS3_PIN                                      GPIO_Pin_8    /*DS3ʹõGPIOܽ*/
#define DS4_PIN                                      GPIO_Pin_9    /*DS4ʹõGPIOܽ*/
#define GPIO_LED_ALL                                 DS1_PIN |DS2_PIN |DS3_PIN |DS4_PIN 


/*IIIKEYض*/
#define RCC_KEY_WAKEUP                               RCC_APB2Periph_GPIOA
#define GPIO_WAKEUP_PORT                             GPIOA    
#define GPIO_WAKEUP                                  GPIO_Pin_0
#define GPIO_KEY1_PORT                               GPIO_WAKEUP_PORT
#define GPIO_KEY1                                    GPIO_WAKEUP
     
#define RCC_KEY_TAMPER                               RCC_APB2Periph_GPIOC
#define GPIO_TAMPER_PORT                             GPIOC    
#define GPIO_TAMPER                                  GPIO_Pin_13
#define GPIO_KEY2_PORT                               GPIO_TAMPER_PORT
#define GPIO_KEY2                                    GPIO_TAMPER

#define RCC_KEY_USER1                                RCC_APB2Periph_GPIOA
#define GPIO_USER1_PORT                              GPIOA    
#define GPIO_USER1                                   GPIO_Pin_8
#define GPIO_KEY3_PORT                               GPIO_USER1_PORT
#define GPIO_KEY3                                    GPIO_USER1

#define RCC_KEY_USER2                                RCC_APB2Periph_GPIOD
#define GPIO_USER2_PORT                              GPIOD    
#define GPIO_USER2                                   GPIO_Pin_3
#define GPIO_KEY4_PORT                               GPIO_USER2_PORT
#define GPIO_KEY4                                    GPIO_USER2


#define  NOKEY  0
#define  KEY1   1
#define  KEY2   2
#define  KEY3   3
#define  KEY4   4
#define  KEY5   5
#define  KEY6   6

/*IIIPCM1770ض*/

/* PCM1770 CS */
#define RCC_PCM1770_CS                            RCC_APB2Periph_GPIOB
#define GPIO_PCM1770_CS_PORT                      GPIOB  
#define GPIO_PCM1770_CS                           GPIO_Pin_11   
 
/*IIILCDض*/
/* LCD_BACK_LIGHT_CONTROL */
#define RCC_LCD_BLC                                RCC_APB2Periph_GPIOA
#define GPIO_LCD_BLC_PORT                          GPIOA
#define GPIO_LCD_BLC                               GPIO_Pin_1   

/* LCD_CS_CONTROL */
#define RCC_LCD_CS                                RCC_APB2Periph_GPIOB
#define GPIO_LCD_CS_PORT                          GPIOB  
#define GPIO_LCD_CS                               GPIO_Pin_12   

/* Select LCD: ChipSelect pin low  */
#define LCD_CS_LOW()     GPIO_ResetBits(GPIO_LCD_CS_PORT, GPIO_LCD_CS)
/* Deselect LCD: ChipSelect pin high */
#define LCD_CS_HIGH()    GPIO_SetBits(GPIO_LCD_CS_PORT, GPIO_LCD_CS)

/*IIISDض*/
/* SD */
#define GPIO_SD_CTRL_PORT                          GPIOD
#define GPIO_SD_NCD                                GPIO_Pin_13   /* input: SD CARD DETECT   ACTIVE 0   */
#define RCC_SD_CTRL                                RCC_APB2Periph_GPIOD

/*IIIUSBض*/
#define USB_DISCONNECT            			GPIOG  
#define USB_DISCONNECT_PIN        			GPIO_Pin_11
#define RCC_APB2Periph_GPIO_DISCONNECT      RCC_APB2Periph_GPIOG

/* SPI_1 pins definition for test */
#define SPI1_PORT   GPIOA
#define SPI1_SCK    GPIO_Pin_5
#define SPI1_MISO   GPIO_Pin_6
#define SPI1_MOSI   GPIO_Pin_7
#define RCC_SPI1    RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1 | RCC_APB2Periph_AFIO

/* SPI_1 pins definition for test */
#define SPI2_PORT   GPIOB
#define SPI2_SCK    GPIO_Pin_13
#define SPI2_MISO   GPIO_Pin_14
#define SPI2_MOSI   GPIO_Pin_15
#define RCC_SPI2    RCC_APB2Periph_GPIOB| RCC_APB1Periph_SPI2 | RCC_APB2Periph_AFIO


//#define console_write(TxBuffer) USART1_SendString((u8 *)TxBuffer) 
#define console_write(TxBuffer) 

// Miscellaneous constants
#define SECTOR_SIZE		512		// sector size in bytes

#define MUSIC_BUFFER_SIZE 512
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Extern variables ----------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/* Select PCM1770: ChipSelect pin low  */
#define SPI_PCM1770_CS_LOW()     GPIO_ResetBits(GPIO_PCM1770_CS_PORT, GPIO_PCM1770_CS)
/* Deselect PCM1770: ChipSelect pin high */
#define SPI_PCM1770_CS_HIGH()    GPIO_SetBits(GPIO_PCM1770_CS_PORT, GPIO_PCM1770_CS)


void LED_config(void);

void Led_Turn_on_all(void);

void Led_Turn_on_1(void);

void Led_Turn_on_2(void);

void Led_Turn_on_3(void);

void Led_Turn_off_all(void);

void Led_Turn_on(u8 led);

void Delay_ARMJISHU(__IO uint32_t nCount);
void Get_ChipSerialNum(void);
void Serial_Init(void);
void USART1_SendString(u8 * TxBuffer);
u8 HEX2ACII (u8 c);
void Int2Str(int i, u8 *p);
void ARMJISH_SHOW(void);


char num2char (char i);
void ShowNum(char c);
void ShowDecNum(char c);
void ShowIntNum(int addr);




u8 ACII2hex (u8 c);



void Show_SerialNum(void);

void exe_cmd(char cmdsn);

void Extension_KEY_Config(void);
u8 ReadKey(void);
void LCD_CONTROL_config(void);
void USB_LED_config(void);
void USB_LED_Turn_on(void);
void USB_LED_Turn_off(void);
void Decrement_TimingDelay(void);
void USB_LED_Spark(void);
void SPI1_Config(void);
void SPI1_Init_For_PCM1770(void);
void PCM1770_Write_reg(u8 WriteAddr, u8 WriteData);
uint16_t SPI1_SendWord(uint16_t word);

void SPI1_Init_For_LCD(void);
u8 SPI1_SendByte(u8 byte);
//void SPI1_SendByte(uint8_t Byte);

/******************* (C) COPYRIGHT 2009 www.armjishu.com *****END OF FILE****/
