/******************** (C) COPYRIGHT 2009 www.armjishu.com ************************
* File Name          : main.c
* Author             : www.armjishu.com Team
* Version            : V3.0.1
* Date               : 09/30/2009
* Description        : 
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "ARMJISHU_SZ_III.h"

/* Private typedef -----------------------------------------------------------*/
//typedef  void (*pFunction)(void);
/* Private define ------------------------------------------------------------*/
#define SaveAddr (0x20004000)
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Extern variables ----------------------------------------------------------*/
static __IO uint32_t TimingDelay = 0;


int pBearJulietSaveAddr =  SaveAddr;

  int MusicIndex = 0;
  __IO int MusicCurrentPlayIndex = 0;
  char MusicName[50][8+1+3+1]={0};  
  u16 MusicBuffer[MUSIC_BUFFER_SIZE] = {0};
  __IO int MusicBufferCurrentPos = 0;
  __IO int MusicBufferReadPos = 0;
  __IO int PlayMusicInSdCard = 0;  
//  __IO bool PlayMusicInSdCard = FALSE;  
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void Delay_ARMJISHU(__IO uint32_t nCount)
{
  for (; nCount != 0; nCount--);
}

/*******************************************************************************
* Function Name  : ReadKey
* Description    : Reads key from demoboard.
* Input          : None
* Output         : None
* Return         : Return RIGHT, LEFT, SEL, UP, DOWN or NOKEY
*******************************************************************************/
/*******************************************************************************
* Function Name  : ReadKey
* Description    : Reads key from demoboard.
* Input          : None
* Output         : None
* Return         : Return RIGHT, LEFT, SEL, UP, DOWN or NOKEY
*******************************************************************************/
u8 ReadKeyD(void)
{
  /* 1 key is pressed */
  if(!GPIO_ReadInputDataBit(GPIO_KEY1_PORT, GPIO_KEY1))
  {
    return KEY1; 
  }	
  /* 2 key is pressed */
  if(!GPIO_ReadInputDataBit(GPIO_KEY2_PORT, GPIO_KEY2))
  {
    return KEY2; 
  }
  /* 3 key is pressed */
  if(!GPIO_ReadInputDataBit(GPIO_KEY3_PORT, GPIO_KEY3))
  {
    return KEY3; 
  }
  /* 4 key is pressed */
  if(!GPIO_ReadInputDataBit(GPIO_KEY4_PORT, GPIO_KEY4))
  {
    return KEY4; 
  }
  /* No key is pressed */
  else 
  {
    return NOKEY;
  }
}




/*******************************************************************************
* Function Name  : SPI1_Config
* Description    : SPI1 IO configuration.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void SPI1_Config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
   
  // Enable SPI1 and GPIOA & GPIOB clocks
  RCC_APB2PeriphClockCmd(RCC_SPI2, ENABLE);

  // Set PA5,6,7 as Output push-pull - SCK, MISO and MOSI
  GPIO_InitStructure.GPIO_Pin = SPI2_SCK | SPI2_MOSI;// | SPI1_MISO;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(SPI2_PORT, &GPIO_InitStructure);
}

/*******************************************************************************
* Function Name  : SPI_FLASH_Init
* Description    : Initializes the peripherals used by the SPI FLASH driver.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI1_Init_For_PCM1770(void)
{
  SPI_InitTypeDef  SPI_InitStructure;

  // Deselect the SPI FLASH: Chip Select high
  //SPI_PCM1770_CS_HIGH();

  // SPI1 configuration
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI1, &SPI_InitStructure);

  // Enable SPI1
  SPI_Cmd(SPI1, ENABLE);   
}


/*******************************************************************************
* Function Name  : SPI_FLASH_PageWrite
* Description    : Writes more than one byte to the FLASH with a single WRITE
*                  cycle(Page WRITE sequence). The number of byte can't exceed
*                  the FLASH page size.
* Input          : - pBuffer : pointer to the buffer  containing the data to be 
*                    written to the FLASH.
*                  - WriteAddr : FLASH's internal address to write to.
*                  - NumByteToWrite : number of bytes to write to the FLASH,
*                    must be equal or less than "SPI_FLASH_PageSize" value. 
* Output         : None
* Return         : None
*******************************************************************************/
void PCM1770_Write_reg(u8 WriteAddr, u8 WriteData)
{
  u16 WriteAddrData;

  /* Send "Write to Memory " instruction */
  WriteAddrData = (0x00FF & WriteAddr);
  WriteAddrData = WriteAddrData << 8;
  WriteAddrData = WriteAddrData | WriteData;

  /* Select the FLASH: Chip Select low */
  SPI_PCM1770_CS_LOW();
  
  SPI1_SendWord(WriteAddrData);

  /* Deselect the FLASH: Chip Select high */
  SPI_PCM1770_CS_HIGH();
  
  console_write("\n\r PCM1770_Write ==> ");
  console_write("WriteAddr:  ");
 // ShowNum(WriteAddr);		  shawn
  console_write(", WriteData:  0x");
  //ShowNum(WriteData);	shawn
}
/*******************************************************************************
* Function Name  : SPI_FLASH_SendByte
* Description    : Sends a byte through the SPI interface and return the byte
*                  received from the SPI bus.
* Input          : byte : byte to send.
* Output         : None
* Return         : The value of the received byte.
*******************************************************************************/
uint16_t SPI1_SendWord(uint16_t word)
{
  /* Loop while DR register in not emplty */
  while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);

  /* Send byte through the SPI1 peripheral */
  SPI_I2S_SendData(SPI1, word);

  //while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);
  /* Wait to receive a byte */
  while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPI1);
}

/*******************************************************************************
* Function Name  : SPI_FLASH_Init
* Description    : Initializes the peripherals used by the SPI FLASH driver.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI1_Init_For_LCD(void)
{
  SPI_InitTypeDef  SPI_InitStructure;

  // SPI1 configuration
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI2, &SPI_InitStructure);

  // Enable SPI1
  SPI_Cmd(SPI2, ENABLE);   
}

/*******************************************************************************
* Function Name  : SPI_FLASH_SendByte
* Description    : Sends a byte through the SPI interface and return the byte
*                  received from the SPI bus.
* Input          : byte : byte to send.
* Output         : None
* Return         : The value of the received byte.
*******************************************************************************/
u8 SPI1_SendByte(u8 byte)
{
  /* Loop while DR register in not emplty */
  while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);

  /* Send byte through the SPI1 peripheral */
  SPI_I2S_SendData(SPI1, byte);

  /* Wait to receive a byte */
  while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPI1);
}
