/**
  ******************************************************************************
  * @file    Project/STM32F10x_StdPeriph_Template/main.c 
  * @author  MCD Application Team
  * @version V3.3.0
  * @date    04/16/2010
  * @brief   Main program body
  ******************************************************************************
  * @copy
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2010 STMicroelectronics</center></h2>
  */ 

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hw_config.h"
#include "platform_config.h"
#include "ARMJISHU_SZ_III.h"
#include <stdio.h>
#include "Waveplayer.h"
#include "I2s_codec.h"



/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Extern variables ----------------------------------------------------------*/
__IO int SD_Card_Detected = 0;


extern int MusicIndex;
extern u16 MusicBuffer[MUSIC_BUFFER_SIZE];
extern __IO int MusicBufferCurrentPos;
extern __IO int MusicBufferReadPos;
extern __IO int PlayMusicInSdCard;  
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

/* Private function prototypes -----------------------------------------------*/

#ifdef __GNUC__
  /* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
     set to 'Yes') calls __io_putchar() */
  #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
  #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */

/* Private functions ---------------------------------------------------------*/

/**
  * @brief  Main program.
  * @param  None
  * @retval None
  */
int main(void)
{
  /*LEDƳʼ*/
  LED_config();
  /*ڳʼ*/
  Serial_Init();
  
  printf("\n\r -----------------------------------------") ; 
  printf("\n\rAudio play test") ; 
  printf("\n\r -----------------------------------------") ; 
  printf("\n\rSerial port initial finish");
  /* I2S GPIOӿ */
  I2S_GPIO_Config(); 

  /*SPI2ӿڳʼ*/
  SPI2_Config();
  PCM1770_CS_config();
  SPI2_Init_For_PCM1770();
  printf("\n\rPCM1770 SPI interface initial finish");

  /*жжȼ*/
  InterruptConfig();
  /*SysTick */
  SysTick_Configuration();

  I2S_CODEC_Init(OutputDevice_SPEAKER, AUDIO_FILE_ADDRESS);//I2C CODECʼ
  I2S_CODEC_Play(1);

  while(1)
  {
      ;
  }


}


/**
  * @brief  Retargets the C library printf function to the USART.
  * @param  None
  * @retval None
  */
PUTCHAR_PROTOTYPE
{
  /* Place your implementation of fputc here */
  /* e.g. write a character to the USART */
  USART_SendData(USART1, (uint8_t) ch);

  /* Loop until the end of transmission */
  while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET)
  {}

  return ch;
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *  where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/**
  * @}
  */


/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
