/******************** (C) COPYRIGHT 2009 www.armjishu.com ************************
* File Name          : main.c
* Author             : www.armjishu.com Team
* Version            : V3.0.1
* Date               : 09/30/2009
* Description        : 
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "ARMJISHU_SZ_III.h"
#include "stm32f10x.h"
#include "stm32f10x_usart.h"
#include "i2s_codec.h"
#include "waveplayer.h"
#include "ff.h"
#include "stdio.h"
extern const char ArmjishuMusic[];
/* Private typedef -----------------------------------------------------------*/
//typedef  void (*pFunction)(void);
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
    FATFS fs;            // Work area (file system object) for logical drive
    FIL fsrc, fdst;      // file objects
    BYTE buffer[51]; // file copy buffer
    FRESULT res;         // FatFs function common result code
    UINT br, bw;         // File R/W count
/* Extern variables ----------------------------------------------------------*/
  uint32_t IntSerial[3];
  static __IO uint32_t TimingDelay = 0;

  int MusicIndex = 0;
  __IO int MusicCurrentPlayIndex = 0;
  char MusicName[50][8+1+3+1]={0};  
  u16 MusicBuffer[MUSIC_BUFFER_SIZE] = {0};
  __IO int MusicBufferCurrentPos = 0;
  __IO int MusicBufferReadPos = 0;
  __IO int PlayMusicInSdCard = 0;  
  
  __IO EXTITrigger_TypeDef SD_CD_EXTITriggerMode = EXTI_Trigger_Falling; 
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void LED_config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  /* Enable GPIOB, GPIOC and AFIO clock */
  RCC_APB2PeriphClockCmd(RCC_GPIO_LED, ENABLE);  
  
  /* LEDs pins configuration */
  GPIO_InitStructure.GPIO_Pin = DS1_PIN |DS2_PIN |DS3_PIN |DS4_PIN ;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIO_LED_PORT, &GPIO_InitStructure);

  GPIO_SetBits(GPIO_LED_PORT, GPIO_LED_ALL);
}

void Led_Turn_on_all(void)
{
	/* Turn On All LEDs */
    GPIO_ResetBits(GPIO_LED_PORT, GPIO_LED_ALL);
}

void Led_Turn_on_1(void)
{
	/* Turn On LED1 */
    GPIO_ResetBits(GPIO_LED_PORT, DS1_PIN);
}

void Led_Turn_on_2(void)
{
	/* Turn On LED2 */
    GPIO_ResetBits(GPIO_LED_PORT, DS2_PIN);
}

void Led_Turn_on_3(void)
{
	/* Turn On LED3 */
    GPIO_ResetBits(GPIO_LED_PORT, DS3_PIN);
}

void Led_Turn_off_all(void)
{
	/* Turn Off All LEDs */
    GPIO_SetBits(GPIO_LED_PORT, GPIO_LED_ALL);
}

void Led_Turn_on(u8 led)
{
    Led_Turn_off_all();

	/* Turn Off Select LED */
    switch(led)
    {
        case 0:
          Led_Turn_on_1();
          break;

        case 1:
          Led_Turn_on_2();
          break;

        case 2:
          Led_Turn_on_3();
          break;
          
        default:
          Led_Turn_on_all();
          break;
    }
}

 
/*******************************************************************************
* Function Name  : PCM1770
* Description    : PCM1770 Chip select configuration.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void PCM1770_CS_config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
   
  // Enable SPI1 and GPIOA & GPIOB clocks
  RCC_APB2PeriphClockCmd(RCC_PCM1770_CS, ENABLE);

  // Configure PB11 as Output push-pull - PCM1770 Chip select
  GPIO_InitStructure.GPIO_Pin = GPIO_PCM1770_CS;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIO_PCM1770_CS_PORT, &GPIO_InitStructure);

  SPI2_PCM1770_CS_HIGH();
}


/*************************************************************************
 * Function Name: Serial_Init
 * Description: Init USARTs
 *************************************************************************/
void Serial_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;
 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1, ENABLE);
  RCC_APB2PeriphResetCmd(RCC_APB2Periph_USART1, DISABLE);

  /* Configure USART1 Tx (PA.09) as alternate function push-pull */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  /* Configure USART1 Rx (PA.10) as input floating */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

/* USART1 configuration ------------------------------------------------------*/
  // USART1 configured as follow:
  USART_InitStructure.USART_BaudRate = 115200;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

  /* Configure the USART1 */
  USART_Init(USART1, &USART_InitStructure);

  /* Enable USART1 */
  USART_Cmd(USART1, ENABLE);
  
}

extern WAVE_FormatTypeDef  WAVE_Format;

  uint8_t memdata[1024];
  


/*******************************************************************************
* Function Name  : Decrement_TimingDelay
* Description    : Decrements the TimingDelay variable.
* Input          : None
* Output         : TimingDelay
* Return         : None
*******************************************************************************/
void Decrement_TimingDelay(void)
{
  if (TimingDelay != 0x00)
  {
    TimingDelay--;
  }
}


/*******************************************************************************
* Function Name  : SPI2_Config
* Description    : SPI2 IO configuration.
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void SPI2_Config(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
   
  // Enable SPI1 and GPIOA & GPIOB clocks
  RCC_APB2PeriphClockCmd(RCC_SPI2, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

  // Set PB13,14,15 as Output push-pull - SCK, MISO and MOSI
  GPIO_InitStructure.GPIO_Pin = SPI2_SCK | SPI2_MOSI | SPI2_MISO;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_Init(SPI2_PORT, &GPIO_InitStructure); 
}

/*******************************************************************************
* Function Name  : SPI_FLASH_Init
* Description    : Initializes the peripherals used by the SPI FLASH driver.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI1_Init_For_PCM1770(void)
{
  SPI_InitTypeDef  SPI_InitStructure;

  // Deselect the SPI FLASH: Chip Select high

  // SPI1 configuration
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI1, &SPI_InitStructure);

  // Enable SPI1
  SPI_Cmd(SPI1, ENABLE);   
}


/*******************************************************************************
* Function Name  : SPI_FLASH_Init
* Description    : Initializes the peripherals used by the SPI FLASH driver.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SPI2_Init_For_PCM1770(void)
{
  SPI_InitTypeDef  SPI_InitStructure;

  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_64;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;
  SPI_Init(SPI2, &SPI_InitStructure);

  SPI_Cmd(SPI2, ENABLE);   
}
/*******************************************************************************
* Function Name  : SPI_FLASH_PageWrite
* Description    : Writes more than one byte to the FLASH with a single WRITE
*                  cycle(Page WRITE sequence). The number of byte can't exceed
*                  the FLASH page size.
* Input          : - pBuffer : pointer to the buffer  containing the data to be 
*                    written to the FLASH.
*                  - WriteAddr : FLASH's internal address to write to.
*                  - NumByteToWrite : number of bytes to write to the FLASH,
*                    must be equal or less than "SPI_FLASH_PageSize" value. 
* Output         : None
* Return         : None
*******************************************************************************/
void PCM1770_Write_reg(u8 WriteAddr, u8 WriteData)
{
  u16 WriteAddrData;

  /* Send "Write to Memory " instruction */
  WriteAddrData = (0x00FF & WriteAddr);
  WriteAddrData = WriteAddrData << 8;
  WriteAddrData = WriteAddrData | WriteData;

  /* Select the FLASH: Chip Select low */
  SPI2_PCM1770_CS_LOW();
  
  SPI2_SendWord(WriteAddrData);

  /* Deselect the FLASH: Chip Select high */
  SPI2_PCM1770_CS_HIGH();
  
  printf("\n\r PCM1770_Write ==> ");
  printf("WriteAddr: 0x%x ",WriteAddr);

  printf(", WriteData:  0x%x",WriteData);
 
}
/*******************************************************************************
* Function Name  : SPI_FLASH_SendByte
* Description    : Sends a byte through the SPI interface and return the byte
*                  received from the SPI bus.
* Input          : byte : byte to send.
* Output         : None
* Return         : The value of the received byte.
*******************************************************************************/
uint16_t SPI2_SendWord(uint16_t word)
{
  /* Loop while DR register in not emplty */
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);

  /* Send byte through the SPI1 peripheral */
  SPI_I2S_SendData(SPI2, word);

  //while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);
  /* Wait to receive a byte */
  while(SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);

  /* Return the byte read from the SPI bus */
  return SPI_I2S_ReceiveData(SPI2);
}







